Debian Bug report logs - #395271
sbuild: incorrectly handles versioned provides

version graph

Package: sbuild; Maintainer for sbuild is Debian buildd-tools Developers <buildd-tools-devel@lists.alioth.debian.org>; Source for sbuild is src:sbuild.

Reported by: Lucas Nussbaum <lucas@lucas-nussbaum.net>

Date: Wed, 25 Oct 2006 22:48:03 UTC

Severity: important

Tags: confirmed, fixed-upstream, patch

Merged with 422879

Found in version sbuild/0.53

Fixed in version sbuild/0.57.4-1

Done: Roger Leigh <rleigh@debian.org>

Bug is archived. No further changes may be made.

Toggle useless messages

View this report as an mbox folder, status mbox, maintainer mbox


Report forwarded to debian-bugs-dist@lists.debian.org, Debian buildd-tools Developers <buildd-tools-devel@lists.alioth.debian.org>:
Bug#395271; Package sbuild. Full text and rfc822 format available.

Acknowledgement sent to Lucas Nussbaum <lucas@lucas-nussbaum.net>:
New Bug report received and forwarded. Copy sent to Debian buildd-tools Developers <buildd-tools-devel@lists.alioth.debian.org>. Full text and rfc822 format available.

Message #5 received at submit@bugs.debian.org (full text, mbox):

From: Lucas Nussbaum <lucas@lucas-nussbaum.net>
To: submit@bugs.debian.org
Subject: sbuild: doesn't handle dependancies resolution correctly for libmail-box-perl
Date: Thu, 26 Oct 2006 00:31:38 +0200
Package: sbuild
Version: 0.52
Severity: important

Hi,

While trying to build libmail-box-perl using sbuild, I ran into a
problem: it seems that sbuild doesn't resolve the build-deps correctly when it involves dealing with Provides. Here is the log:

** Using build dependencies supplied by package:
Build-Depends: debhelper (>= 4.0)
Build-Depends-Indep: perl (>= 5.6.0-16), libtimedate-perl,
libio-stringy-perl, libmime-types-perl (>= 1.004), libmailt
ools-perl, libobject-realize-later-perl (>= 0.14),
libscalar-list-utils-perl (>= 1.13) | perl (>= 5.8.2-2), liburi-per
l (>= 1.23), libdigest-hmac-perl, libuser-identity-perl,
libfile-remove-perl, libtext-autoformat-perl, netbase, libhtm
l-format-perl, libtest-harness-perl (>= 2.62)
Checking for already installed source dependencies...
debhelper: missing
perl: already installed (5.8.8-6.1 >= 5.6.0-16 is satisfied)
libtimedate-perl: missing
libio-stringy-perl: missing
libmime-types-perl: missing
libmailtools-perl: missing
libobject-realize-later-perl: missing
libscalar-list-utils-perl: already installed (=*=PROVIDED=*= >= 1.13 is
satisfied)
liburi-perl: missing
libdigest-hmac-perl: missing
libuser-identity-perl: missing
libfile-remove-perl: missing
libtext-autoformat-perl: missing
netbase: already installed (4.25)
libhtml-format-perl: missing
libtest-harness-perl: already installed (=*=PROVIDED=*= >= 2.62 is
satisfied)
Checking for source dependency conflicts...
Reading package lists...
Building dependency tree...
The following extra packages will be installed:
  file gettext html2text intltool-debian libdigest-sha1-perl
libfont-afm-perl
  libhtml-parser-perl libhtml-tagset-perl libhtml-tree-perl libmagic1
  libtext-reform-perl po-debconf
Suggested packages:
  dh-make cvs gettext-doc libwww-perl
Recommended packages:
  libmail-sendmail-perl libcompress-zlib-perl
The following NEW packages will be installed:
  debhelper file gettext html2text intltool-debian libdigest-hmac-perl
  libdigest-sha1-perl libfile-remove-perl libfont-afm-perl
libhtml-format-perl
  libhtml-parser-perl libhtml-tagset-perl libhtml-tree-perl
libio-stringy-perl
  libmagic1 libmailtools-perl libmime-types-perl
libobject-realize-later-perl
  libtext-autoformat-perl libtext-reform-perl libtimedate-perl
liburi-perl
  libuser-identity-perl po-debconf
0 upgraded, 24 newly installed, 0 to remove and 9 not upgraded.
Need to get 0B/3754kB of archives.
After unpacking 11.8MB of additional disk space will be used.
WARNING: The following packages cannot be authenticated!
  libmagic1 file html2text gettext intltool-debian po-debconf debhelper
  libdigest-sha1-perl libdigest-hmac-perl libfile-remove-perl
libfont-afm-perl
  libhtml-tagset-perl liburi-perl libhtml-parser-perl libhtml-tree-perl
  libhtml-format-perl libio-stringy-perl libtimedate-perl
libmailtools-perl
  libmime-types-perl libobject-realize-later-perl libtext-reform-perl
  libtext-autoformat-perl libuser-identity-perl
Authentication warning overridden.
Selecting previously deselected package libmagic1.
(Reading database ... 12435 files and directories currently installed.)
Unpacking libmagic1 (from .../file/libmagic1_4.17-4_i386.deb) ...
Selecting previously deselected package file.
Unpacking file (from .../f/file/file_4.17-4_i386.deb) ...
Selecting previously deselected package html2text.
Unpacking html2text (from .../html2text_1.3.2a-3_i386.deb) ...
Selecting previously deselected package gettext.
Unpacking gettext (from .../gettext_0.14.6-1_i386.deb) ...
Selecting previously deselected package intltool-debian.
Unpacking intltool-debian (from
.../intltool-debian_0.35.0+20060710.1_all.deb) ...
Selecting previously deselected package po-debconf.
Unpacking po-debconf (from .../po-debconf_1.0.6_all.deb) ...
Selecting previously deselected package debhelper.
Unpacking debhelper (from .../debhelper_5.0.40_all.deb) ...
Selecting previously deselected package libdigest-sha1-perl.
Unpacking libdigest-sha1-perl (from
.../libdigest-sha1-perl_2.11-1_i386.deb) ...
Selecting previously deselected package libdigest-hmac-perl.
Unpacking libdigest-hmac-perl (from
.../libdigest-hmac-perl_1.01-4_all.deb) ...
Selecting previously deselected package libfile-remove-perl.
Unpacking libfile-remove-perl (from
.../libfile-remove-perl_0.31-1_all.deb) ...
Selecting previously deselected package libfont-afm-perl.
Unpacking libfont-afm-perl (from .../libfont-afm-perl_1.19-1_all.deb)
...
Selecting previously deselected package libhtml-tagset-perl.
Unpacking libhtml-tagset-perl (from
.../libhtml-tagset-perl_3.10-2_all.deb) ...
Selecting previously deselected package liburi-perl.
Unpacking liburi-perl (from .../liburi-perl_1.35-2_all.deb) ...
Selecting previously deselected package libhtml-parser-perl.
Unpacking libhtml-parser-perl (from
.../libhtml-parser-perl_3.55-1_i386.deb) ...
Selecting previously deselected package libhtml-tree-perl.
Unpacking libhtml-tree-perl (from
.../libhtml-tree-perl_3.19.01-2_all.deb) ...
Selecting previously deselected package libhtml-format-perl.
Unpacking libhtml-format-perl (from
.../libhtml-format-perl_2.04-1_all.deb) ...
Selecting previously deselected package libio-stringy-perl.
Unpacking libio-stringy-perl (from
.../libio-stringy-perl_2.110-1_all.deb) ...
Selecting previously deselected package libtimedate-perl.
Unpacking libtimedate-perl (from .../libtimedate-perl_1.1600-5_all.deb)
...
Selecting previously deselected package libmailtools-perl.
Unpacking libmailtools-perl (from
.../libmailtools-perl_1.74-0.1_all.deb) ...
Selecting previously deselected package libmime-types-perl.
Unpacking libmime-types-perl (from
.../libmime-types-perl_1.17-2_all.deb) ...
Selecting previously deselected package libobject-realize-later-perl.
Unpacking libobject-realize-later-perl (from
.../libobject-realize-later-perl_0.15-3_all.deb) ...
Selecting previously deselected package libtext-reform-perl.
Unpacking libtext-reform-perl (from
.../libtext-reform-perl_1.11-5_all.deb) ...
Selecting previously deselected package libtext-autoformat-perl.
Unpacking libtext-autoformat-perl (from
.../libtext-autoformat-perl_1.13-1_all.deb) ...
Selecting previously deselected package libuser-identity-perl.
Unpacking libuser-identity-perl (from
.../libuser-identity-perl_0.90-3_all.deb) ...
Setting up libmagic1 (4.17-4) ...

Setting up file (4.17-4) ...
Setting up html2text (1.3.2a-3) ...

Setting up gettext (0.14.6-1) ...

Setting up intltool-debian (0.35.0+20060710.1) ...
Setting up po-debconf (1.0.6) ...
Setting up debhelper (5.0.40) ...
Setting up libdigest-sha1-perl (2.11-1) ...
Setting up libdigest-hmac-perl (1.01-4) ...
Setting up libfile-remove-perl (0.31-1) ...
Setting up libfont-afm-perl (1.19-1) ...
Setting up libhtml-tagset-perl (3.10-2) ...
Setting up liburi-perl (1.35-2) ...
Setting up libhtml-parser-perl (3.55-1) ...
Setting up libhtml-tree-perl (3.19.01-2) ...
Setting up libhtml-format-perl (2.04-1) ...
Setting up libio-stringy-perl (2.110-1) ...

Setting up libtimedate-perl (1.1600-5) ...
Setting up libmailtools-perl (1.74-0.1) ...
Setting up libmime-types-perl (1.17-2) ...
Setting up libobject-realize-later-perl (0.15-3) ...
Setting up libtext-reform-perl (1.11-5) ...
Setting up libtext-autoformat-perl (1.13-1) ...
Setting up libuser-identity-perl (0.90-3) ...
Checking correctness of source dependencies...
Kernel: Linux 2.6.12-1-amd64-k8-smp i386 (x86_64)
Toolchain package versions: libc6-dev_2.3.6.ds1-4
linux-kernel-headers_2.6.18-3 gcc-4.1_4.1.1-13 g++-4.1_4.1.1-13 binu
tils_2.17-3 libstdc++6-4.1-dev_4.1.1-13 libstdc++6_4.1.1-13
------------------------------------------------------------------------------
dpkg-source: warning: could not verify signature on
/tmp/build/libmail-box-perl_2.068-1.dsc since gpg isn't installed
dpkg-source: extracting libmail-box-perl in libmail-box-perl-2.068
dpkg-source: unpacking libmail-box-perl_2.068.orig.tar.gz
dpkg-source: applying /tmp/build/libmail-box-perl_2.068-1.diff.gz
dpkg-buildpackage: source package is libmail-box-perl
dpkg-buildpackage: source version is 2.068-1
dpkg-buildpackage: host architecture i386
dpkg-buildpackage: source version without epoch 2.068-1
dpkg-checkbuilddeps: Unmet build dependencies: libtest-harness-perl (>=
2.62)
dpkg-buildpackage: Build dependencies/conflicts unsatisfied; aborting.
dpkg-buildpackage: (Use -d flag to override.)
******************************************************************************

It would be great if either:
- sbuild could say which package provides a specific dependancy, to help
  debugging this
- this was handled correctly (but I'm not sure of what "correctly" means
  here)

Another possible example of this bug is libtest-base-perl and its
dependancy on libtest-simple-perl.

Thank you,
-- 
| Lucas Nussbaum
| lucas@lucas-nussbaum.net   http://www.lucas-nussbaum.net/ |
| jabber: lucas@nussbaum.fr             GPG: 1024D/023B3F4F |



Information forwarded to debian-bugs-dist@lists.debian.org, Debian buildd-tools Developers <buildd-tools-devel@lists.alioth.debian.org>:
Bug#395271; Package sbuild. Full text and rfc822 format available.

Acknowledgement sent to Roger Leigh <rleigh@whinlatter.ukfsn.org>:
Extra info received and forwarded to list. Copy sent to Debian buildd-tools Developers <buildd-tools-devel@lists.alioth.debian.org>. Full text and rfc822 format available.

Message #10 received at 395271@bugs.debian.org (full text, mbox):

From: Roger Leigh <rleigh@whinlatter.ukfsn.org>
To: Lucas Nussbaum <lucas@lucas-nussbaum.net>
Cc: 395271@bugs.debian.org,
Subject: Re: [Buildd-tools-devel] Bug#395271: sbuild: doesn't handle dependancies resolution correctly for libmail-box-perl
Date: Fri, 27 Oct 2006 23:15:29 +0100
[Message part 1 (text/plain, inline)]
tags 395271 + confirmed
reassign 395271 dpkg-dev
thanks

Lucas Nussbaum <lucas@lucas-nussbaum.net> writes:

> While trying to build libmail-box-perl using sbuild, I ran into a
> problem: it seems that sbuild doesn't resolve the build-deps
> correctly when it involves dealing with Provides. Here is the log:

> libscalar-list-utils-perl: already installed (=*=PROVIDED=*= >= 1.13 is
> satisfied)
> dpkg-source: warning: could not verify signature on
> /tmp/build/libmail-box-perl_2.068-1.dsc since gpg isn't installed
> dpkg-source: extracting libmail-box-perl in libmail-box-perl-2.068
> dpkg-source: unpacking libmail-box-perl_2.068.orig.tar.gz
> dpkg-source: applying /tmp/build/libmail-box-perl_2.068-1.diff.gz
> dpkg-buildpackage: source package is libmail-box-perl
> dpkg-buildpackage: source version is 2.068-1
> dpkg-buildpackage: host architecture i386
> dpkg-buildpackage: source version without epoch 2.068-1
> dpkg-checkbuilddeps: Unmet build dependencies: libtest-harness-perl (>=
> 2.62)
> dpkg-buildpackage: Build dependencies/conflicts unsatisfied; aborting.
> dpkg-buildpackage: (Use -d flag to override.)

> It would be great if either:
> - sbuild could say which package provides a specific dependancy, to help
>   debugging this
> - this was handled correctly (but I'm not sure of what "correctly" means
>   here)

It's dpkg-checkbuilddeps (part of dpkg-dev) that's failing, rather
than sbuild.  I'm reassigning to dpkg-dev.

Summary: libtest-harness-perl is a binary package, but is also
Provided by perl-modules.  sbuild notices the perl-modules Provides
libtest-harness-perl, so doesn't install libtest-harness-perl.
dpkg-checkbuilddeps appears not to notice the Provides.

> Another possible example of this bug is libtest-base-perl and its
> dependancy on libtest-simple-perl.

Summary: libtest-base-perl is a binary package, but is also Provided
by perl-modules.  sbuild notices the perl-modules Provides
libtest-base-perl, so doesn't install libtest-base-perl.
dpkg-checkbuilddeps appears not to notice the Provides.


Regards,
Roger

-- 
  .''`.  Roger Leigh
 : :' :  Debian GNU/Linux             http://people.debian.org/~rleigh/
 `. `'   Printing on GNU/Linux?       http://gutenprint.sourceforge.net/
   `-    GPG Public Key: 0x25BFB848   Please GPG sign your mail.
[libmail-box-perl_2.068-1_20061027-2301 (text/plain, inline)]
Automatic build of libmail-box-perl_2.068-1 on hardknott by sbuild/powerpc 0.52
Build started at 20061027-2301
******************************************************************************
Checking available source versions...
Fetching source files...
Reading package lists...
Building dependency tree...
Need to get 594kB of source archives.
Get:1 http://ftp.uk.debian.org unstable/main libmail-box-perl 2.068-1 (dsc) [1276B]
Get:2 http://ftp.uk.debian.org unstable/main libmail-box-perl 2.068-1 (tar) [589kB]
Get:3 http://ftp.uk.debian.org unstable/main libmail-box-perl 2.068-1 (diff) [3680B]
Fetched 594kB in 21s (28.0kB/s)
Download complete and in download only mode
** Using build dependencies supplied by package:
Build-Depends: debhelper (>= 4.0)
Build-Depends-Indep: perl (>= 5.6.0-16), libtimedate-perl, libio-stringy-perl, libmime-types-perl (>= 1.004), libmailtools-perl, libobject-realize-later-perl (>= 0.14), libscalar-list-utils-perl (>= 1.13) | perl (>= 5.8.2-2), liburi-perl (>= 1.23), libdigest-hmac-perl, libuser-identity-perl, libfile-remove-perl, libtext-autoformat-perl, netbase, libhtml-format-perl, libtest-harness-perl (>= 2.62)
Checking for already installed source dependencies...
debhelper: already installed (5.0.40 >= 4.0 is satisfied)
perl: already installed (5.8.8-6.1 >= 5.6.0-16 is satisfied)
libtimedate-perl: missing
libio-stringy-perl: missing
libmime-types-perl: missing
Using default version 1.17-2
libmailtools-perl: missing
libobject-realize-later-perl: missing
Using default version 0.15-3
libscalar-list-utils-perl: already installed (=*=PROVIDED=*= >= 1.13 is satisfied)
liburi-perl: missing
Using default version 1.35-2
libdigest-hmac-perl: missing
libuser-identity-perl: missing
libfile-remove-perl: missing
libtext-autoformat-perl: missing
netbase: already installed (4.27)
libhtml-format-perl: missing
libtest-harness-perl: already installed (=*=PROVIDED=*= >= 2.62 is satisfied)
Checking for source dependency conflicts...
Reading package lists...
Building dependency tree...
The following extra packages will be installed:
  libdigest-sha1-perl libfont-afm-perl libhtml-parser-perl libhtml-tagset-perl
  libhtml-tree-perl libtext-reform-perl
Suggested packages:
  libwww-perl
The following NEW packages will be installed:
  libdigest-hmac-perl libdigest-sha1-perl libfile-remove-perl libfont-afm-perl
  libhtml-format-perl libhtml-parser-perl libhtml-tagset-perl
  libhtml-tree-perl libio-stringy-perl libmailtools-perl libmime-types-perl
  libobject-realize-later-perl libtext-autoformat-perl libtext-reform-perl
  libtimedate-perl liburi-perl libuser-identity-perl
0 upgraded, 17 newly installed, 0 to remove and 0 not upgraded.
Need to get 491kB/907kB of archives.
After unpacking 3183kB of additional disk space will be used.
WARNING: The following packages cannot be authenticated!
  libdigest-sha1-perl libdigest-hmac-perl libfile-remove-perl libfont-afm-perl
  libhtml-tagset-perl liburi-perl libhtml-parser-perl libhtml-tree-perl
  libhtml-format-perl libio-stringy-perl libtimedate-perl libmailtools-perl
  libmime-types-perl libobject-realize-later-perl libtext-reform-perl
  libtext-autoformat-perl libuser-identity-perl
Authentication warning overridden.
Get:1 http://ftp.uk.debian.org unstable/main libdigest-sha1-perl 2.11-1 [26.3kB]
Get:2 http://ftp.uk.debian.org unstable/main libdigest-hmac-perl 1.01-4 [10.6kB]
Get:3 http://ftp.uk.debian.org unstable/main libfile-remove-perl 0.31-1 [8962B]
Get:4 http://ftp.uk.debian.org unstable/main libfont-afm-perl 1.19-1 [13.7kB]
Get:5 http://ftp.uk.debian.org unstable/main libhtml-format-perl 2.04-1 [37.9kB]
Get:6 http://ftp.uk.debian.org unstable/main libio-stringy-perl 2.110-1 [88.6kB]
Get:7 http://ftp.uk.debian.org unstable/main libtimedate-perl 1.1600-5 [32.7kB]
Get:8 http://ftp.uk.debian.org unstable/main libmailtools-perl 1.74-0.1 [85.7kB]
Get:9 http://ftp.uk.debian.org unstable/main libmime-types-perl 1.17-2 [28.3kB]
Get:10 http://ftp.uk.debian.org unstable/main libobject-realize-later-perl 0.15-3 [17.4kB]
Get:11 http://ftp.uk.debian.org unstable/main libtext-reform-perl 1.11-5 [34.9kB]
Get:12 http://ftp.uk.debian.org unstable/main libtext-autoformat-perl 1.13-1 [30.2kB]
Get:13 http://ftp.uk.debian.org unstable/main libuser-identity-perl 0.90-3 [75.5kB]
Fetched 491kB in 15s (30.8kB/s)
Selecting previously deselected package libdigest-sha1-perl.
(Reading database ... 11350 files and directories currently installed.)
Unpacking libdigest-sha1-perl (from .../libdigest-sha1-perl_2.11-1_powerpc.deb) ...
Selecting previously deselected package libdigest-hmac-perl.
Unpacking libdigest-hmac-perl (from .../libdigest-hmac-perl_1.01-4_all.deb) ...
Selecting previously deselected package libfile-remove-perl.
Unpacking libfile-remove-perl (from .../libfile-remove-perl_0.31-1_all.deb) ...
Selecting previously deselected package libfont-afm-perl.
Unpacking libfont-afm-perl (from .../libfont-afm-perl_1.19-1_all.deb) ...
Selecting previously deselected package libhtml-tagset-perl.
Unpacking libhtml-tagset-perl (from .../libhtml-tagset-perl_3.10-2_all.deb) ...
Selecting previously deselected package liburi-perl.
Unpacking liburi-perl (from .../liburi-perl_1.35-2_all.deb) ...
Selecting previously deselected package libhtml-parser-perl.
Unpacking libhtml-parser-perl (from .../libhtml-parser-perl_3.55-1_powerpc.deb) ...
Selecting previously deselected package libhtml-tree-perl.
Unpacking libhtml-tree-perl (from .../libhtml-tree-perl_3.19.01-2_all.deb) ...
Selecting previously deselected package libhtml-format-perl.
Unpacking libhtml-format-perl (from .../libhtml-format-perl_2.04-1_all.deb) ...
Selecting previously deselected package libio-stringy-perl.
Unpacking libio-stringy-perl (from .../libio-stringy-perl_2.110-1_all.deb) ...
Selecting previously deselected package libtimedate-perl.
Unpacking libtimedate-perl (from .../libtimedate-perl_1.1600-5_all.deb) ...
Selecting previously deselected package libmailtools-perl.
Unpacking libmailtools-perl (from .../libmailtools-perl_1.74-0.1_all.deb) ...
Selecting previously deselected package libmime-types-perl.
Unpacking libmime-types-perl (from .../libmime-types-perl_1.17-2_all.deb) ...
Selecting previously deselected package libobject-realize-later-perl.
Unpacking libobject-realize-later-perl (from .../libobject-realize-later-perl_0.15-3_all.deb) ...
Selecting previously deselected package libtext-reform-perl.
Unpacking libtext-reform-perl (from .../libtext-reform-perl_1.11-5_all.deb) ...
Selecting previously deselected package libtext-autoformat-perl.
Unpacking libtext-autoformat-perl (from .../libtext-autoformat-perl_1.13-1_all.deb) ...
Selecting previously deselected package libuser-identity-perl.
Unpacking libuser-identity-perl (from .../libuser-identity-perl_0.90-3_all.deb) ...
Setting up libdigest-sha1-perl (2.11-1) ...
Setting up libdigest-hmac-perl (1.01-4) ...
Setting up libfile-remove-perl (0.31-1) ...
Setting up libfont-afm-perl (1.19-1) ...
Setting up libhtml-tagset-perl (3.10-2) ...
Setting up liburi-perl (1.35-2) ...
Setting up libhtml-parser-perl (3.55-1) ...
Setting up libhtml-tree-perl (3.19.01-2) ...
Setting up libhtml-format-perl (2.04-1) ...
Setting up libio-stringy-perl (2.110-1) ...

Setting up libtimedate-perl (1.1600-5) ...
Setting up libmailtools-perl (1.74-0.1) ...
Setting up libmime-types-perl (1.17-2) ...
Setting up libobject-realize-later-perl (0.15-3) ...
Setting up libtext-reform-perl (1.11-5) ...
Setting up libtext-autoformat-perl (1.13-1) ...
Setting up libuser-identity-perl (0.90-3) ...
Checking correctness of source dependencies...
Kernel: Linux 2.6.18-1-powerpc powerpc (ppc)
Toolchain package versions: libc6-dev_2.3.6.ds1-7 linux-kernel-headers_2.6.18-6 gcc-4.1_4.1.1-17 g++-4.1_4.1.1-17 binutils_2.17-3 libstdc++6-4.1-dev_4.1.1-17 libstdc++6_4.1.1-17
------------------------------------------------------------------------------
dpkg-source: extracting libmail-box-perl in libmail-box-perl-2.068
dpkg-source: unpacking libmail-box-perl_2.068.orig.tar.gz
dpkg-source: applying /home/rleigh/build/libmail-box-perl_2.068-1.diff.gz
dpkg-buildpackage: source package is libmail-box-perl
dpkg-buildpackage: source version is 2.068-1
dpkg-buildpackage: source changed by gregor herrmann <gregor+debian@comodo.priv.at>
dpkg-buildpackage: host architecture powerpc
dpkg-buildpackage: source version without epoch 2.068-1
dpkg-checkbuilddeps: Unmet build dependencies: libtest-harness-perl (>= 2.62)
dpkg-buildpackage: Build dependencies/conflicts unsatisfied; aborting.
dpkg-buildpackage: (Use -d flag to override.)
******************************************************************************
Build finished at 20061027-2302
FAILED [dpkg-buildpackage died]
------------------------------------------------------------------------------
(Reading database ... 11769 files and directories currently installed.)
Removing libmime-types-perl ...
Removing libio-stringy-perl ...
Removing libuser-identity-perl ...
Removing libobject-realize-later-perl ...
Removing libmailtools-perl ...
Removing libtext-autoformat-perl ...
Removing libfile-remove-perl ...
Removing libdigest-hmac-perl ...
Removing libhtml-format-perl ...
Removing libtimedate-perl ...
Removing libfont-afm-perl ...
Removing libdigest-sha1-perl ...
Removing libhtml-tree-perl ...
Removing libtext-reform-perl ...
Removing libhtml-parser-perl ...
Removing liburi-perl ...
Removing libhtml-tagset-perl ...
******************************************************************************
Finished at 20061027-2302
Build needed 00:00:04, 3756k disk space
[Message part 3 (application/pgp-signature, inline)]

Tags added: confirmed Request was from Roger Leigh <rleigh@whinlatter.ukfsn.org> to control@bugs.debian.org. Full text and rfc822 format available.

Bug reassigned from package `sbuild' to `dpkg-dev'. Request was from Roger Leigh <rleigh@whinlatter.ukfsn.org> to control@bugs.debian.org. Full text and rfc822 format available.

Changed Bug title to dpkg-dev: dpkg-checkbuilddeps does not take into account Provided packages from sbuild: doesn't handle dependancies resolution correctly for libmail-box-perl. Request was from Guillem Jover <guillem@debian.org> to control@bugs.debian.org. (Tue, 20 Mar 2007 04:03:04 GMT) Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, Dpkg Developers <team@dpkg.org>:
Bug#395271; Package dpkg-dev. Full text and rfc822 format available.

Acknowledgement sent to Guillem Jover <guillem@debian.org>:
Extra info received and forwarded to list. Copy sent to Dpkg Developers <team@dpkg.org>. Full text and rfc822 format available.

Message #21 received at 395271@bugs.debian.org (full text, mbox):

From: Guillem Jover <guillem@debian.org>
To: Roger Leigh <rleigh@whinlatter.ukfsn.org>, 395271@bugs.debian.org
Cc: control@bugs.debian.org, sbuild@packages.debian.org
Subject: Re: Bug#395271: sbuild: doesn't handle dependancies resolution correctly for libmail-box-perl
Date: Sat, 26 May 2007 08:58:47 +0300
reassign 395271 sbuild
retitle 395271 sbuild: incorrectly handles versioned provides
thanks

On Fri, 2006-10-27 at 23:15:29 +0100, Roger Leigh wrote:
> Lucas Nussbaum <lucas@lucas-nussbaum.net> writes:
> > While trying to build libmail-box-perl using sbuild, I ran into a
> > problem: it seems that sbuild doesn't resolve the build-deps
> > correctly when it involves dealing with Provides. Here is the log:
> 
> > libscalar-list-utils-perl: already installed (=*=PROVIDED=*= >= 1.13 is
> > satisfied)
> > dpkg-source: warning: could not verify signature on
> > /tmp/build/libmail-box-perl_2.068-1.dsc since gpg isn't installed
> > dpkg-source: extracting libmail-box-perl in libmail-box-perl-2.068
> > dpkg-source: unpacking libmail-box-perl_2.068.orig.tar.gz
> > dpkg-source: applying /tmp/build/libmail-box-perl_2.068-1.diff.gz
> > dpkg-buildpackage: source package is libmail-box-perl
> > dpkg-buildpackage: source version is 2.068-1
> > dpkg-buildpackage: host architecture i386
> > dpkg-buildpackage: source version without epoch 2.068-1
> > dpkg-checkbuilddeps: Unmet build dependencies: libtest-harness-perl (>=
> > 2.62)
> > dpkg-buildpackage: Build dependencies/conflicts unsatisfied; aborting.
> > dpkg-buildpackage: (Use -d flag to override.)
> 
> > It would be great if either:
> > - sbuild could say which package provides a specific dependancy, to help
> >   debugging this
> > - this was handled correctly (but I'm not sure of what "correctly" means
> >   here)
> 
> It's dpkg-checkbuilddeps (part of dpkg-dev) that's failing, rather
> than sbuild.  I'm reassigning to dpkg-dev.

dpkg-checkbuilddeps supports Provides correctly, the problem here is
that it does not support versioned Provides (as is the case for the
whole package managment stack). So I suppose sbuild should fail
sooner, and all those perl packages should be fixed to update their
Build-Dependencies (given that perl-modules is Build-Essential, just
removing the offending packages which are provided by it should be
enough).

regards,
guillem



Bug reassigned from package `dpkg-dev' to `sbuild'. Request was from Guillem Jover <guillem@debian.org> to control@bugs.debian.org. (Sat, 26 May 2007 06:00:06 GMT) Full text and rfc822 format available.

Changed Bug title to `sbuild: incorrectly handles versioned provides' from `dpkg-dev: dpkg-checkbuilddeps does not take into account Provided packages'. Request was from Guillem Jover <guillem@debian.org> to control@bugs.debian.org. (Sat, 26 May 2007 06:00:07 GMT) Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, Debian buildd-tools Developers <buildd-tools-devel@lists.alioth.debian.org>:
Bug#395271; Package sbuild. Full text and rfc822 format available.

Acknowledgement sent to Lucas Nussbaum <lucas@lucas-nussbaum.net>:
Extra info received and forwarded to list. Copy sent to Debian buildd-tools Developers <buildd-tools-devel@lists.alioth.debian.org>. Full text and rfc822 format available.

Message #30 received at 395271@bugs.debian.org (full text, mbox):

From: Lucas Nussbaum <lucas@lucas-nussbaum.net>
To: Roger Leigh <rleigh@whinlatter.ukfsn.org>, 395271@bugs.debian.org
Subject: Re: Bug#395271: sbuild: doesn't handle dependancies resolution correctly for libmail-box-perl
Date: Tue, 5 Jun 2007 08:39:41 +0200
On 26/05/07 at 08:58 +0300, Guillem Jover wrote:
> reassign 395271 sbuild
> retitle 395271 sbuild: incorrectly handles versioned provides
> thanks
> 
> On Fri, 2006-10-27 at 23:15:29 +0100, Roger Leigh wrote:
> > Lucas Nussbaum <lucas@lucas-nussbaum.net> writes:
> > > While trying to build libmail-box-perl using sbuild, I ran into a
> > > problem: it seems that sbuild doesn't resolve the build-deps
> > > correctly when it involves dealing with Provides. Here is the log:
> > 
> > > libscalar-list-utils-perl: already installed (=*=PROVIDED=*= >= 1.13 is
> > > satisfied)
> > > dpkg-source: warning: could not verify signature on
> > > /tmp/build/libmail-box-perl_2.068-1.dsc since gpg isn't installed
> > > dpkg-source: extracting libmail-box-perl in libmail-box-perl-2.068
> > > dpkg-source: unpacking libmail-box-perl_2.068.orig.tar.gz
> > > dpkg-source: applying /tmp/build/libmail-box-perl_2.068-1.diff.gz
> > > dpkg-buildpackage: source package is libmail-box-perl
> > > dpkg-buildpackage: source version is 2.068-1
> > > dpkg-buildpackage: host architecture i386
> > > dpkg-buildpackage: source version without epoch 2.068-1
> > > dpkg-checkbuilddeps: Unmet build dependencies: libtest-harness-perl (>=
> > > 2.62)
> > > dpkg-buildpackage: Build dependencies/conflicts unsatisfied; aborting.
> > > dpkg-buildpackage: (Use -d flag to override.)
> > 
> > > It would be great if either:
> > > - sbuild could say which package provides a specific dependancy, to help
> > >   debugging this
> > > - this was handled correctly (but I'm not sure of what "correctly" means
> > >   here)
> > 
> > It's dpkg-checkbuilddeps (part of dpkg-dev) that's failing, rather
> > than sbuild.  I'm reassigning to dpkg-dev.
> 
> dpkg-checkbuilddeps supports Provides correctly, the problem here is
> that it does not support versioned Provides (as is the case for the
> whole package managment stack). So I suppose sbuild should fail
> sooner, and all those perl packages should be fixed to update their
> Build-Dependencies (given that perl-modules is Build-Essential, just
> removing the offending packages which are provided by it should be
> enough).

It's not that simple, actually. Let's consider svk 2.0.1-1:
** Using build dependencies supplied by package:
Build-Depends: debhelper (>= 4.0.2)
Build-Depends-Indep: perl (>= 5.8.0-7), gnupg, libalgorithm-annotate-perl, libalgorithm-diff-perl (>> 1.19.01), libapp-cli-perl, libclass-accessor-perl, libclass-autouse-perl (>> 1.15), libclass-data-inheritable-perl, libcompress-zlib-perl, libdata-hierarchy-perl (>> 0.30), libfile-spec-perl (>> 3.17), libfile-temp-perl (>> 0.17), libfreezethaw-perl, libio-digest-perl, liblist-moreutils-perl, liblocale-maketext-lexicon-perl (>> 0.62), liblocale-maketext-simple-perl (>> 0.16), libpath-class-perl (>> 0.16), libperlio-eol-perl (>> 0.13), libperlio-via-dynamic-perl (>> 0.11), libperlio-via-symlink-perl (>> 0.02), libpod-escapes-perl, libpod-simple-perl, libsvn-mirror-perl (>> 0.71), libsvn-simple-perl (>> 0.27), libterm-readkey-perl, libuniversal-require-perl, liburi-perl, libversion-perl, libyaml-syck-perl (>> 0.60)
[...]
libfile-temp-perl: already installed (=*=PROVIDED=*= >> 0.17 is satisfied)
[...]
dpkg-checkbuilddeps: Unmet build dependencies: libfile-temp-perl (>> 0.17)
dpkg-buildpackage: Build dependencies/conflicts unsatisfied; aborting.

It build-depends on perl, which itself depends on perl-modules, which
provides libfile-temp-perl. However, the version of File/Temp.pm in
perl-modules is 0.16. So the maintainers knows this one is not enough,
and explicitely requests >> 0.17.

I think that the correct way to handle that on sbuild side is to install
the specified package even if the package is provided by another
package, in the case it's a versioned depend. So that would give
something like:
libfile-temp-perl: provided by an installed package, but versioned dependancy => missing

I have the same problem with lots of packages that b-dep on
linux-kernel-headers (>> 2.5.999), since I switched to linux-libc-dev,
and linux-kernel-headers is provided by linux-libc-dev.
 
How hard would that be to implement something like that ?
-- 
| Lucas Nussbaum
| lucas@lucas-nussbaum.net   http://www.lucas-nussbaum.net/ |
| jabber: lucas@nussbaum.fr             GPG: 1024D/023B3F4F |



Information forwarded to debian-bugs-dist@lists.debian.org, Debian buildd-tools Developers <buildd-tools-devel@lists.alioth.debian.org>:
Bug#395271; Package sbuild. Full text and rfc822 format available.

Acknowledgement sent to Niko Tyni <ntyni@debian.org>:
Extra info received and forwarded to list. Copy sent to Debian buildd-tools Developers <buildd-tools-devel@lists.alioth.debian.org>. Full text and rfc822 format available.

Message #35 received at 395271@bugs.debian.org (full text, mbox):

From: Niko Tyni <ntyni@debian.org>
To: Lucas Nussbaum <lucas@lucas-nussbaum.net>, 395271@bugs.debian.org
Subject: Re: Bug#395271: sbuild: incorrectly handles versioned provides
Date: Sun, 24 Feb 2008 21:49:26 +0200
tag 395271 patch
thanks

On Tue, Jun 05, 2007 at 08:39:41AM +0200, Lucas Nussbaum wrote:
> On 26/05/07 at 08:58 +0300, Guillem Jover wrote:
> > reassign 395271 sbuild
> > retitle 395271 sbuild: incorrectly handles versioned provides
> > thanks

> I think that the correct way to handle that on sbuild side is to install
> the specified package even if the package is provided by another
> package, in the case it's a versioned depend. So that would give
> something like:
> libfile-temp-perl: provided by an installed package, but versioned dependancy => missing
> 
> I have the same problem with lots of packages that b-dep on
> linux-kernel-headers (>> 2.5.999), since I switched to linux-libc-dev,
> and linux-kernel-headers is provided by linux-libc-dev.
>  
> How hard would that be to implement something like that ?

Looking at the sbuild code, provided packages are just marked installed
with the magic version "=*=PROVIDED=*=", which compares as greater than
just about anything else (except versions with an epoch, of course.)

Just prepending a tilde to the magic version to make it sort
before anything else seems to fix this bug.  I just tried with
libclass-trait-perl, and the result is exactly what was hoped for.

Without the change:

Build-Depends-Indep: perl (>= 5.8.0-7), libtest-differences-perl (>= 0.47), libmodule-build-perl, libtest-simple-perl (>= 0.62)
[...]
libtest-simple-perl: already installed (=*=PROVIDED=*= >= 0.62 is satisfied)
[...]
dpkg-checkbuilddeps: Unmet build dependencies: libtest-simple-perl (>= 0.62)
dpkg-buildpackage: warning: Build dependencies/conflicts unsatisfied; aborting.

With the change:

libtest-simple-perl: non-matching version installed (~*=PROVIDED=*= ! >= 0.62)
Using default version 0.62-1
[...]
The following NEW packages will be installed:
  bsdmainutils debhelper file gettext gettext-base groff-base html2text
  intltool-debian libalgorithm-diff-perl libgomp1 libmagic1
  libtest-differences-perl libtest-simple-perl libtext-diff-perl man-db
  po-debconf

and the package builds succesfully.

Please consider the attached trivial patch.

Cheers,
-- 
Niko Tyni   ntyni@debian.org




Tags added: patch Request was from Niko Tyni <ntyni@debian.org> to control@bugs.debian.org. (Sun, 24 Feb 2008 19:51:07 GMT) Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, Debian buildd-tools Developers <buildd-tools-devel@lists.alioth.debian.org>:
Bug#395271; Package sbuild. Full text and rfc822 format available.

Acknowledgement sent to Niko Tyni <ntyni@debian.org>:
Extra info received and forwarded to list. Copy sent to Debian buildd-tools Developers <buildd-tools-devel@lists.alioth.debian.org>. Full text and rfc822 format available.

Message #42 received at 395271@bugs.debian.org (full text, mbox):

From: Niko Tyni <ntyni@debian.org>
To: 395271@bugs.debian.org
Subject: Re: [Buildd-tools-devel] Bug#395271: sbuild: incorrectly handles versioned provides
Date: Sun, 24 Feb 2008 23:15:53 +0200
[Message part 1 (text/plain, inline)]
On Sun, Feb 24, 2008 at 09:09:29PM +0000, Roger Leigh wrote:
> Niko Tyni <ntyni@debian.org> writes:
> 
> > Please consider the attached trivial patch.
> 
> Thanks.  But, did you attach it?  I didn't see it.

Hmph, sorry. Here we go for real.

Cheers,
-- 
Niko Tyni   ntyni@debian.org
[sbuild-patch (text/plain, attachment)]

Information forwarded to debian-bugs-dist@lists.debian.org, Debian buildd-tools Developers <buildd-tools-devel@lists.alioth.debian.org>:
Bug#395271; Package sbuild. Full text and rfc822 format available.

Acknowledgement sent to Lucas Nussbaum <lucas@lucas-nussbaum.net>:
Extra info received and forwarded to list. Copy sent to Debian buildd-tools Developers <buildd-tools-devel@lists.alioth.debian.org>. Full text and rfc822 format available.

Message #47 received at 395271@bugs.debian.org (full text, mbox):

From: Lucas Nussbaum <lucas@lucas-nussbaum.net>
To: Niko Tyni <ntyni@debian.org>
Cc: 395271@bugs.debian.org
Subject: Re: Bug#395271: sbuild: incorrectly handles versioned provides
Date: Sun, 24 Feb 2008 22:33:32 +0100
On 24/02/08 at 21:49 +0200, Niko Tyni wrote:
> tag 395271 patch
> thanks
> 
> Please consider the attached trivial patch.
 
Seems like you got hit by the classic (for mutt users) "oops, forgot the
patch" syndrome.
-- 
| Lucas Nussbaum
| lucas@lucas-nussbaum.net   http://www.lucas-nussbaum.net/ |
| jabber: lucas@nussbaum.fr             GPG: 1024D/023B3F4F |




Information forwarded to debian-bugs-dist@lists.debian.org, Debian buildd-tools Developers <buildd-tools-devel@lists.alioth.debian.org>:
Bug#395271; Package sbuild. Full text and rfc822 format available.

Acknowledgement sent to Roger Leigh <rleigh@whinlatter.ukfsn.org>:
Extra info received and forwarded to list. Copy sent to Debian buildd-tools Developers <buildd-tools-devel@lists.alioth.debian.org>. Full text and rfc822 format available.

Message #52 received at 395271@bugs.debian.org (full text, mbox):

From: Roger Leigh <rleigh@whinlatter.ukfsn.org>
To: Niko Tyni <ntyni@debian.org>
Cc: 395271@bugs.debian.org
Subject: Re: [Buildd-tools-devel] Bug#395271: sbuild: incorrectly handles versioned provides
Date: Sun, 24 Feb 2008 21:09:29 +0000
[Message part 1 (text/plain, inline)]
Niko Tyni <ntyni@debian.org> writes:

> Please consider the attached trivial patch.

Thanks.  But, did you attach it?  I didn't see it.


Regards,
Roger

-- 
  .''`.  Roger Leigh
 : :' :  Debian GNU/Linux             http://people.debian.org/~rleigh/
 `. `'   Printing on GNU/Linux?       http://gutenprint.sourceforge.net/
   `-    GPG Public Key: 0x25BFB848   Please GPG sign your mail.
[Message part 2 (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, Debian buildd-tools Developers <buildd-tools-devel@lists.alioth.debian.org>:
Bug#395271; Package sbuild. Full text and rfc822 format available.

Acknowledgement sent to Roger Leigh <rleigh@whinlatter.ukfsn.org>:
Extra info received and forwarded to list. Copy sent to Debian buildd-tools Developers <buildd-tools-devel@lists.alioth.debian.org>. Full text and rfc822 format available.

Message #57 received at 395271@bugs.debian.org (full text, mbox):

From: Roger Leigh <rleigh@whinlatter.ukfsn.org>
To: Niko Tyni <ntyni@debian.org>
Cc: 395271@bugs.debian.org
Subject: Re: [Buildd-tools-devel] Bug#395271: Bug#395271: sbuild: incorrectly handles versioned provides
Date: Tue, 26 Feb 2008 23:27:13 +0000
[Message part 1 (text/plain, inline)]
Niko Tyni <ntyni@debian.org> writes:

> On Sun, Feb 24, 2008 at 09:09:29PM +0000, Roger Leigh wrote:
>> Niko Tyni <ntyni@debian.org> writes:
>> 
>> > Please consider the attached trivial patch.
>> 
>> Thanks.  But, did you attach it?  I didn't see it.
>
> Hmph, sorry. Here we go for real.

Thanks.  I tried out the patch, but it fails to build the packages
mentioned earlier in the bug report:

sbuild -s -A -d sid libmail-box-perl_2.080-1
sbuild -s -A -d sid svk_2.0.1-1

(done on a testing system with an unstable chroot)

Checking for already installed source dependencies...
debhelper: missing
Using default version 6.0.5
quilt: missing
libdigest-hmac-perl: missing
libemail-abstract-perl: missing
libemail-simple-perl: missing
libfile-remove-perl: missing
libhtml-format-perl: missing
libio-stringy-perl: missing
libmailtools-perl: missing
Using default version 2.02-1
libmime-tools-perl: missing
libmime-types-perl: missing
Using default version 1.23-1
libobject-realize-later-perl: missing
Using default version 0.18-1
libscalar-list-utils-perl: non-matching version installed (~*=PROVIDED=*= ! >= 1
.13)
Default version of libscalar-list-utils-perl not sufficient, no suitable alterna
tive found. I probably should dep-wait this one.
Package installation not possible
Source-dependencies not satisfied; skipping libmail-box-perl

I think a special case needs adding in either version_compare() or
prior to each version_compare call.


Regards,
Roger

-- 
  .''`.  Roger Leigh
 : :' :  Debian GNU/Linux             http://people.debian.org/~rleigh/
 `. `'   Printing on GNU/Linux?       http://gutenprint.sourceforge.net/
   `-    GPG Public Key: 0x25BFB848   Please GPG sign your mail.
[Message part 2 (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, Debian buildd-tools Developers <buildd-tools-devel@lists.alioth.debian.org>:
Bug#395271; Package sbuild. Full text and rfc822 format available.

Acknowledgement sent to Niko Tyni <ntyni@debian.org>:
Extra info received and forwarded to list. Copy sent to Debian buildd-tools Developers <buildd-tools-devel@lists.alioth.debian.org>. Full text and rfc822 format available.

Message #62 received at 395271@bugs.debian.org (full text, mbox):

From: Niko Tyni <ntyni@debian.org>
To: 395271@bugs.debian.org
Subject: Re: [Buildd-tools-devel] sbuild: incorrectly handles versioned provides
Date: Wed, 27 Feb 2008 17:16:57 +0200
On Tue, Feb 26, 2008 at 11:27:13PM +0000, Roger Leigh wrote:

> Thanks.  I tried out the patch, but it fails to build the packages
> mentioned earlier in the bug report:
> 
> sbuild -s -A -d sid libmail-box-perl_2.080-1
> sbuild -s -A -d sid svk_2.0.1-1

> libscalar-list-utils-perl: non-matching version installed (~*=PROVIDED=*= ! >= 1
> .13)
> Default version of libscalar-list-utils-perl not sufficient, no suitable alterna
> tive found. I probably should dep-wait this one.
> Package installation not possible
> Source-dependencies not satisfied; skipping libmail-box-perl
> 
> I think a special case needs adding in either version_compare() or
> prior to each version_compare call.

The libmail-box-perl case hits another issue, filed as #403246 ("sbuild
dependancy resolution fails when b-dep on A | B ; A uninstallable").
See also the discussion in #422879: "As I understand it, that's the
intended upstream behaviour."

libmail-box-perl build-depends on 

 libscalar-list-utils-perl (>= 1.13) | perl (>= 5.8.2-2)

but libscalar-list-utils-perl is only available in sid as a provided
package, so the versioned dependency cannot be satisfied at all and
sbuild gives up without considering the other option.

As for svk, I'm able to build 2.0.1-1 with current sid and a patched
sbuild. What's the error message you're getting?

Cheers,
-- 
Niko Tyni   ntyni@debian.org




Information forwarded to debian-bugs-dist@lists.debian.org, Debian buildd-tools Developers <buildd-tools-devel@lists.alioth.debian.org>:
Bug#395271; Package sbuild. Full text and rfc822 format available.

Acknowledgement sent to Lucas Nussbaum <lucas@lucas-nussbaum.net>:
Extra info received and forwarded to list. Copy sent to Debian buildd-tools Developers <buildd-tools-devel@lists.alioth.debian.org>. Full text and rfc822 format available.

Message #67 received at 395271@bugs.debian.org (full text, mbox):

From: Lucas Nussbaum <lucas@lucas-nussbaum.net>
To: control@bugs.debian.org
Cc: 395271@bugs.debian.org
Subject: tagging 395271
Date: Fri, 23 May 2008 08:39:49 +0200
# Automatically generated email from bts, devscripts version 2.10.27
# removing patch tag since the proposed patch doesnt work
tags 395271 - patch





Tags removed: patch Request was from Lucas Nussbaum <lucas@lucas-nussbaum.net> to control@bugs.debian.org. (Fri, 23 May 2008 06:45:05 GMT) Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, Debian buildd-tools Developers <buildd-tools-devel@lists.alioth.debian.org>:
Bug#395271; Package sbuild. Full text and rfc822 format available.

Acknowledgement sent to Niko Tyni <ntyni@debian.org>:
Extra info received and forwarded to list. Copy sent to Debian buildd-tools Developers <buildd-tools-devel@lists.alioth.debian.org>. Full text and rfc822 format available.

Message #74 received at 395271@bugs.debian.org (full text, mbox):

From: Niko Tyni <ntyni@debian.org>
To: Lucas Nussbaum <lucas@lucas-nussbaum.net>, 395271@bugs.debian.org
Subject: Re: Bug#395271: tagging 395271
Date: Fri, 23 May 2008 13:11:01 +0300
On Fri, May 23, 2008 at 08:39:49AM +0200, Lucas Nussbaum wrote:
> # Automatically generated email from bts, devscripts version 2.10.27
> # removing patch tag since the proposed patch doesnt work
> tags 395271 - patch

Did you actually try the patch? Roger never commented on my reply where
I think I made myself clear:

> > The libmail-box-perl case hits another issue, filed as #403246 ("sbuild
> > dependancy resolution fails when b-dep on A | B ; A uninstallable").
> > See also the discussion in #422879: "As I understand it, that's the
> > intended upstream behaviour."
> > 
> > libmail-box-perl build-depends on 
> > 
> >  libscalar-list-utils-perl (>= 1.13) | perl (>= 5.8.2-2)
> > 
> > but libscalar-list-utils-perl is only available in sid as a provided
> > package, so the versioned dependency cannot be satisfied at all and
> > sbuild gives up without considering the other option.
> > 
> > As for svk, I'm able to build 2.0.1-1 with current sid and a patched
> > sbuild. What's the error message you're getting?

I still think _this_ bug is that "=*=PROVIDED=*=" sorts after just
about every version number instead of before them. As the log in the
initial report says, sbuild thought the provided libtest-harness-perl
satisfied the versioned dependency while dpkg-checkbuilddeps didn't
(and rightly so, see policy 7.4).

Cheers,
-- 
Niko Tyni   ntyni@debian.org




Information forwarded to debian-bugs-dist@lists.debian.org, Debian buildd-tools Developers <buildd-tools-devel@lists.alioth.debian.org>:
Bug#395271; Package sbuild. Full text and rfc822 format available.

Acknowledgement sent to Lucas Nussbaum <lucas@lucas-nussbaum.net>:
Extra info received and forwarded to list. Copy sent to Debian buildd-tools Developers <buildd-tools-devel@lists.alioth.debian.org>. Full text and rfc822 format available.

Message #79 received at 395271@bugs.debian.org (full text, mbox):

From: Lucas Nussbaum <lucas@lucas-nussbaum.net>
To: control@bugs.debian.org
Cc: 395271@bugs.debian.org, ntyni@debian.org, rleigh@whinlatter.ukfsn.org
Subject: Re: Bug#395271: tagging 395271
Date: Fri, 23 May 2008 12:04:07 +0200
tags 395271 + patch
thanks

Actually, the patch works very well. The following patches failed to
build with the current sbuild in unstable, but build fine with the
patch:
bioperl_1.5.2.102-3
libclass-trait-perl_0.22-2
libemail-send-perl_2.192-2
libmodule-packaged-perl_0.86-1
libnet-dns-resolver-programmable-perl_0.003-1
libplucene-perl_1.25-2
libpod-constants-perl_0.16-1
libtest-base-perl_0.47-1.1
libtest-distribution-perl_2.00-1
libtest-exception-perl_0.27-1
libtext-wikiformat-perl_0.78-1
libtime-piece-mysql-perl_0.05-2
mail-spf-perl_2.005-1
mime-tools_5.426-1
openguides_0.61-4
zim_0.25-1
zoidberg_0.96-1

Roger, could you apply it?

The following packages still fail to build with sbuild:
libwww-perl_5.812-1 (would need sbuild to understand B-dep: a | b. will
file bug when this bug is fixed)

libmail-box-perl_2.082-1 (same case as libwww-perl)

svk_2.0.2-1 (version depends on liblocale-maketext-simple-perl, but
perl-modules conflicts with liblocale-maketext-simple-perl (<< O.16) =>
bug in svk
-- 
| Lucas Nussbaum
| lucas@lucas-nussbaum.net   http://www.lucas-nussbaum.net/ |
| jabber: lucas@nussbaum.fr             GPG: 1024D/023B3F4F |




Tags added: patch Request was from Lucas Nussbaum <lucas@lucas-nussbaum.net> to control@bugs.debian.org. (Fri, 23 May 2008 11:39:04 GMT) Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, Debian buildd-tools Developers <buildd-tools-devel@lists.alioth.debian.org>:
Bug#395271; Package sbuild. Full text and rfc822 format available.

Acknowledgement sent to Lucas Nussbaum <lucas@lucas-nussbaum.net>:
Extra info received and forwarded to list. Copy sent to Debian buildd-tools Developers <buildd-tools-devel@lists.alioth.debian.org>. Full text and rfc822 format available.

Message #86 received at 395271@bugs.debian.org (full text, mbox):

From: Lucas Nussbaum <lucas@lucas-nussbaum.net>
To: Niko Tyni <ntyni@debian.org>
Cc: 395271@bugs.debian.org
Subject: Re: Bug#395271: tagging 395271
Date: Fri, 23 May 2008 13:37:34 +0200
On 23/05/08 at 13:11 +0300, Niko Tyni wrote:
> On Fri, May 23, 2008 at 08:39:49AM +0200, Lucas Nussbaum wrote:
> > # Automatically generated email from bts, devscripts version 2.10.27
> > # removing patch tag since the proposed patch doesnt work
> > tags 395271 - patch
> 
> Did you actually try the patch? Roger never commented on my reply where
> I think I made myself clear:

Yup, see my other mail. Your patch rocks ;)
-- 
| Lucas Nussbaum
| lucas@lucas-nussbaum.net   http://www.lucas-nussbaum.net/ |
| jabber: lucas@nussbaum.fr             GPG: 1024D/023B3F4F |




Information forwarded to debian-bugs-dist@lists.debian.org, Debian buildd-tools Developers <buildd-tools-devel@lists.alioth.debian.org>:
Bug#395271; Package sbuild. Full text and rfc822 format available.

Acknowledgement sent to Roger Leigh <rleigh@whinlatter.ukfsn.org>:
Extra info received and forwarded to list. Copy sent to Debian buildd-tools Developers <buildd-tools-devel@lists.alioth.debian.org>. Full text and rfc822 format available.

Message #91 received at 395271@bugs.debian.org (full text, mbox):

From: Roger Leigh <rleigh@whinlatter.ukfsn.org>
To: Lucas Nussbaum <lucas@lucas-nussbaum.net>, 395271@bugs.debian.org
Cc: control@bugs.debian.org, ntyni@debian.org
Subject: Re: [Buildd-tools-devel] Bug#395271: tagging 395271
Date: Fri, 23 May 2008 13:22:46 +0100
On Fri, May 23, 2008 at 12:04:07PM +0200, Lucas Nussbaum wrote:
> tags 395271 + patch
> thanks
> 
> Roger, could you apply it?

I'll review and apply it tonight, time permitting.

By the way, since you are using sbuild on a buildd and are actively
using it, would you like to join the buildd-tools project team?  This
would give you write access to the git repo, so you could hack on sbuild
directly if you wished.


Regards,
Roger

-- 
  .''`.  Roger Leigh
 : :' :  Debian GNU/Linux             http://people.debian.org/~rleigh/
 `. `'   Printing on GNU/Linux?       http://gutenprint.sourceforge.net/
   `-    GPG Public Key: 0x25BFB848   Please GPG sign your mail.




Information forwarded to debian-bugs-dist@lists.debian.org, Debian buildd-tools Developers <buildd-tools-devel@lists.alioth.debian.org>:
Bug#395271; Package sbuild. Full text and rfc822 format available.

Acknowledgement sent to Roger Leigh <rleigh@whinlatter.ukfsn.org>:
Extra info received and forwarded to list. Copy sent to Debian buildd-tools Developers <buildd-tools-devel@lists.alioth.debian.org>. Full text and rfc822 format available.

Message #96 received at 395271@bugs.debian.org (full text, mbox):

From: Roger Leigh <rleigh@whinlatter.ukfsn.org>
To: Lucas Nussbaum <lucas@lucas-nussbaum.net>
Cc: 395271@bugs.debian.org, control@bugs.debian.org, ntyni@debian.org
Subject: Re: [Buildd-tools-devel] Bug#395271: tagging 395271
Date: Sun, 25 May 2008 21:55:53 +0100
[Message part 1 (text/plain, inline)]
tags 395271 + fixed-upstream pending
thanks

Lucas Nussbaum <lucas@lucas-nussbaum.net> writes:

> Actually, the patch works very well. The following patches failed to
> build with the current sbuild in unstable, but build fine with the
> patch:

[...]

> Roger, could you apply it?

Done.  Due to refactoring, the patch I applied is to a different
source file, so I attached the changed version below.  It's also at

http://git.debian.org/?p=buildd-tools/sbuild.git;a=commitdiff;h=8bc3477690728ec2c61e8240b63df15b06de933a

> The following packages still fail to build with sbuild:
> libwww-perl_5.812-1 (would need sbuild to understand B-dep: a | b. will
> file bug when this bug is fixed)
>
> libmail-box-perl_2.082-1 (same case as libwww-perl)
>
> svk_2.0.2-1 (version depends on liblocale-maketext-simple-perl, but
> perl-modules conflicts with liblocale-maketext-simple-perl (<< O.16) =>
> bug in svk

OK.  If these are separate bugs in sbuild (which haven't already been
filed--there are some long-standing issues with some build-deps that
really need tackling), please could you file separate bugs.


Thanks,
Roger


diff --git a/debian/changelog b/debian/changelog
index 74f6356..89b6ea1 100644
--- a/debian/changelog
+++ b/debian/changelog
@@ -4,8 +4,12 @@ sbuild (0.57.3-1) unstable; urgency=low
   * --chroot and --arch now work together (Closes: #479714).
   * Use schroot "Session Purged" flag rather than "Session Cloned"
     (Closes: #482804).  Thanks to Timothy G Abbott.
+  * Handle version provides correctly, by using "~*=PROVIDED=*=" in place
+    of "=*=PROVIDED=*=" as the package version (Closes: #395271).  Thanks
+    to Niko Tyni for this patch.
+  * 
 
- -- Roger Leigh <rleigh@debian.org>  Sun, 25 May 2008 21:32:39 +0100
+ -- Roger Leigh <rleigh@debian.org>  Sun, 25 May 2008 21:48:33 +0100
 
 sbuild (0.57.2-1) unstable; urgency=low
 
diff --git a/lib/Sbuild/Build.pm b/lib/Sbuild/Build.pm
index 86be0fc..8ddb9f0 100644
--- a/lib/Sbuild/Build.pm
+++ b/lib/Sbuild/Build.pm
@@ -1375,7 +1375,7 @@ sub get_dpkg_status (\$@) {
 	if ($status !~ /\sinstalled$/) {
 	    $result{$pkg}->{'Installed'} = 0
 		if !(exists($result{$pkg}) &&
-		     $result{$pkg}->{'Version'} eq '=*=PROVIDED=*=');
+		     $result{$pkg}->{'Version'} eq '~*=PROVIDED=*=');
 	    next;
 	}
 	if (!defined $version || $version eq "") {
@@ -1387,7 +1387,7 @@ sub get_dpkg_status (\$@) {
 	if isin( $pkg, @interest );
 	if ($provides) {
 	    foreach (split( /\s*,\s*/, $provides )) {
-		$result{$_} = { Installed => 1, Version => '=*=PROVIDED=*=' }
+		$result{$_} = { Installed => 1, Version => '~*=PROVIDED=*=' }
 		if isin( $_, @interest ) and (not exists($result{$_}) or
 					      ($result{$_}->{'Installed'} == 0));
 	    }


-- 
  .''`.  Roger Leigh
 : :' :  Debian GNU/Linux             http://people.debian.org/~rleigh/
 `. `'   Printing on GNU/Linux?       http://gutenprint.sourceforge.net/
   `-    GPG Public Key: 0x25BFB848   Please GPG sign your mail.
[Message part 2 (application/pgp-signature, inline)]

Tags added: fixed-upstream, pending Request was from Roger Leigh <rleigh@whinlatter.ukfsn.org> to control@bugs.debian.org. (Sun, 25 May 2008 21:05:44 GMT) Full text and rfc822 format available.

Forcibly Merged 395271 422879. Request was from Lucas Nussbaum <lucas@lucas-nussbaum.net> to control@bugs.debian.org. (Mon, 26 May 2008 06:57:02 GMT) Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, Debian buildd-tools Developers <buildd-tools-devel@lists.alioth.debian.org>:
Bug#395271; Package sbuild. Full text and rfc822 format available.

Acknowledgement sent to Lucas Nussbaum <lucas@lucas-nussbaum.net>:
Extra info received and forwarded to list. Copy sent to Debian buildd-tools Developers <buildd-tools-devel@lists.alioth.debian.org>. Full text and rfc822 format available.

Message #105 received at 395271@bugs.debian.org (full text, mbox):

From: Lucas Nussbaum <lucas@lucas-nussbaum.net>
To: Roger Leigh <rleigh@whinlatter.ukfsn.org>, 395271@bugs.debian.org
Cc: ntyni@debian.org
Subject: Re: Bug#395271: [Buildd-tools-devel] Bug#395271: tagging 395271
Date: Mon, 26 May 2008 11:13:57 +0200
[Message part 1 (text/plain, inline)]
On 25/05/08 at 21:55 +0100, Roger Leigh wrote:
> tags 395271 + fixed-upstream pending
> thanks
> 
> Lucas Nussbaum <lucas@lucas-nussbaum.net> writes:
> 
> > Actually, the patch works very well. The following patches failed to
> > build with the current sbuild in unstable, but build fine with the
> > patch:
> 
> [...]
> 
> > Roger, could you apply it?
> 
> Done.  Due to refactoring, the patch I applied is to a different
> source file, so I attached the changed version below.  It's also at
> 
> http://git.debian.org/?p=buildd-tools/sbuild.git;a=commitdiff;h=8bc3477690728ec2c61e8240b63df15b06de933a
> 
> > The following packages still fail to build with sbuild:
> > libwww-perl_5.812-1 (would need sbuild to understand B-dep: a | b. will
> > file bug when this bug is fixed)
> >
> > libmail-box-perl_2.082-1 (same case as libwww-perl)
> >
> > svk_2.0.2-1 (version depends on liblocale-maketext-simple-perl, but
> > perl-modules conflicts with liblocale-maketext-simple-perl (<< O.16) =>
> > bug in svk
> 
> OK.  If these are separate bugs in sbuild (which haven't already been
> filed--there are some long-standing issues with some build-deps that
> really need tackling), please could you file separate bugs.

No, I think they are bugs in the packages. I'll investigate them later
and file bugs.
-- 
| Lucas Nussbaum
| lucas@lucas-nussbaum.net   http://www.lucas-nussbaum.net/ |
| jabber: lucas@nussbaum.fr             GPG: 1024D/023B3F4F |
[signature.asc (application/pgp-signature, inline)]

Reply sent to Roger Leigh <rleigh@debian.org>:
You have taken responsibility. Full text and rfc822 format available.

Notification sent to Lucas Nussbaum <lucas@lucas-nussbaum.net>:
Bug acknowledged by developer. Full text and rfc822 format available.

Message #110 received at 395271-close@bugs.debian.org (full text, mbox):

From: Roger Leigh <rleigh@debian.org>
To: 395271-close@bugs.debian.org
Subject: Bug#395271: fixed in sbuild 0.57.4-1
Date: Sun, 06 Jul 2008 12:02:06 +0000
Source: sbuild
Source-Version: 0.57.4-1

We believe that the bug you reported is fixed in the latest version of
sbuild, which is due to be installed in the Debian FTP archive:

sbuild_0.57.4-1.diff.gz
  to pool/main/s/sbuild/sbuild_0.57.4-1.diff.gz
sbuild_0.57.4-1.dsc
  to pool/main/s/sbuild/sbuild_0.57.4-1.dsc
sbuild_0.57.4-1_all.deb
  to pool/main/s/sbuild/sbuild_0.57.4-1_all.deb
sbuild_0.57.4.orig.tar.gz
  to pool/main/s/sbuild/sbuild_0.57.4.orig.tar.gz
wanna-build_0.57.4-1_all.deb
  to pool/main/s/sbuild/wanna-build_0.57.4-1_all.deb



A summary of the changes between this version and the previous one is
attached.

Thank you for reporting the bug, which will now be closed.  If you
have further comments please address them to 395271@bugs.debian.org,
and the maintainer will reopen the bug report if appropriate.

Debian distribution maintenance software
pp.
Roger Leigh <rleigh@debian.org> (supplier of updated sbuild package)

(This message was generated automatically at their request; if you
believe that there is a problem with it please contact the archive
administrators by mailing ftpmaster@debian.org)


-----BEGIN PGP SIGNED MESSAGE-----
Hash: SHA1

Format: 1.8
Date: Sun, 06 Jul 2008 12:21:06 +0100
Source: sbuild
Binary: sbuild wanna-build
Architecture: source all
Version: 0.57.4-1
Distribution: unstable
Urgency: low
Maintainer: Debian buildd-tools Developers <buildd-tools-devel@lists.alioth.debian.org>
Changed-By: Roger Leigh <rleigh@debian.org>
Description: 
 sbuild     - Tool for building Debian binary packages from Debian sources
 wanna-build - Database to track building of Debian binary packages from Debian 
Closes: 395271 449251 482456 482804 482922 482931 483654
Changes: 
 sbuild (0.57.4-1) unstable; urgency=low
 .
   * New release.
   * debian/control: Update to Standards Version 3.8.0.
   * Use schroot "Session Purged" flag rather than "Session Cloned"
     (Closes: #482804).  Thanks to Timothy G Abbott.
   * Handle version provides correctly, by using "~*=PROVIDED=*=" in place
     of "=*=PROVIDED=*=" as the package version (Closes: #395271).  Thanks
     to Niko Tyni for this patch.
   * Don't include epoch version in directory names (Closes: #482456).
     Thanks to Raphael Hertzog.
   * man/sbuild-setup.7.in: Replace references to buildd.chroot with
     sbuild-createchroot, and adduser with sbuild-adduser (Closes: #483654).
     Thanks to Marc Fargas.
   * Package name, version, build directory and associated information are
     now contained within Sbuild::Build objects.  This allows stripping of
     epoch to construct correct unpack directory location
     (Closes: #482931, #482922).
   * Warnings due to uninitialised variables are no longer reproducible
     (Closes: #449251).
Checksums-Sha1: 
 d0d30649a8052c6fa5308ce0a6da2966b9081a2c 1244 sbuild_0.57.4-1.dsc
 60b6af8ad3292cada42f1d59207d697b4b760003 287345 sbuild_0.57.4.orig.tar.gz
 b7eadf9b0f54bfbbfd44ac393c75fca1e7b4835b 23130 sbuild_0.57.4-1.diff.gz
 aa4d5d965df0e4865b8e4c4e76c94fa87a3ffebe 96960 sbuild_0.57.4-1_all.deb
 b705909a30f3c465447e522708ac23414903b76e 57518 wanna-build_0.57.4-1_all.deb
Checksums-Sha256: 
 39be433eb3ddf53cb3802c9d48b4524225ecc1ec8344a5e403d651d15e87b06e 1244 sbuild_0.57.4-1.dsc
 4ff65586a013cf9afdc0f9039601252e8ab5ecb6fb17ee35d2ceb94d78069965 287345 sbuild_0.57.4.orig.tar.gz
 629ab81487a13a9cc1ca07fef489e134d2919f6ef8fc2afa8ddd66525a1cb9de 23130 sbuild_0.57.4-1.diff.gz
 8c3a937a47bcc87729ab10524e8469b41add66e2c8f0e7824e674f4373edc694 96960 sbuild_0.57.4-1_all.deb
 52a222f2142bc5b7d4875520a23e877825e975664483af8d63ae64fb0dbfbc93 57518 wanna-build_0.57.4-1_all.deb
Files: 
 848996dee38e6a6a8f193dc987658b7c 1244 devel extra sbuild_0.57.4-1.dsc
 24d8d9c106ced475edca32e766d0bf19 287345 devel extra sbuild_0.57.4.orig.tar.gz
 1e16e350426e7128ee65042a5ed03245 23130 devel extra sbuild_0.57.4-1.diff.gz
 6c2bd57efb3a333173e7c658803c5d0c 96960 devel extra sbuild_0.57.4-1_all.deb
 7c284328f6f619c3a45c5153d5b4126b 57518 devel extra wanna-build_0.57.4-1_all.deb

-----BEGIN PGP SIGNATURE-----
Version: GnuPG v1.4.9 (GNU/Linux)

iEYEARECAAYFAkhwsOcACgkQVcFcaSW/uEg3qQCgyDXx3afvwGzXDcOGHamfmut1
DfMAni0rq0Sh+wOrgrnjAgoKMyZtDnLP
=xMj4
-----END PGP SIGNATURE-----





Reply sent to Roger Leigh <rleigh@debian.org>:
You have taken responsibility. Full text and rfc822 format available.

Notification sent to Lucas Nussbaum <lucas@lucas-nussbaum.net>:
Bug acknowledged by developer. Full text and rfc822 format available.

Bug archived. Request was from Debbugs Internal Request <owner@bugs.debian.org> to internal_control@bugs.debian.org. (Fri, 15 Aug 2008 07:37:59 GMT) Full text and rfc822 format available.

Send a report that this bug log contains spam.


Debian bug tracking system administrator <owner@bugs.debian.org>. Last modified: Sun Apr 20 00:44:52 2014; Machine Name: buxtehude.debian.org

Debian Bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997,2003 nCipher Corporation Ltd, 1994-97 Ian Jackson.